/*
*  This script defines functions used to show and to remove duplicates within ManageDuplicates.xul
*
* Author: Stéphane BERTIN
* http://bookmarkdd.mozdev.org
*
* Lot of things are in comments : a big clean up need to be done in same time to drop compatibility with firefox <4.0
* It is keep until remove all duplicates function is back
*/

//TODO verify that parent folder are not rssFeed
//URL in RSSFeed are not duplicate
//Only Feed URL is duplicated
var DupNum = 0;
var Totalnum = 0;
var CountRemoveAllDuplicates = 0;
//var AutoDeletedBookmarkSameFolder= 0;
//var AutoDeletedBookmarkSelectedFolder= 0;
//var URLParents = new Array();
//var URLrdfNodes = new Array();
//var rssFeed = /(.rss)$/i;	//Verify if url is a FeedURL
//var isNotRootFolder = /( \> )/;		//if there is ' > ' it is not the root folder.

var URLlist = document.getElementById("URLlist");
var FolderslistID = document.getElementById("Folderslist");
var BookmarksCount = document.getElementById("bookmarks_count");

//var AutoDeleteSameFolder = UserPrefs.getPref("bool","AutoDelete.BookmarkInSameFolder");
//var AutoDeleteSelectedFolder = UserPrefs.getPref("bool","AutoDelete.BookmarkInSelectedFolder");
var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
//var AutoDeleteAllDuplicates = false;

const TRUNCATENUM = UserPrefs.getPref("int","URL.truncateNum");

// Since Fx4.0 : Load PlaceUtils module used to show BookmarkProperty panel
try {
    Components.utils.import("resource://gre/modules/PlacesUtils.jsm");
    Components.utils.import("resource://gre/modules/PlacesUIUtils.jsm");
} catch(ex) {
}

// Get Bookmarks Service
try {
    var bmsvc = Components.classes["@mozilla.org/browser/nav-bookmarks-service;1"].getService(Components.interfaces.nsINavBookmarksService);
} catch(ex) {
    alert("BookmarkDD - internal error : Could not get nav-bookmarks-service\n");
}

// Get IO Service : used for newURI
try {
    var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
} catch(ex) {
    alert("BookmarkDD - internal error : Could not get io-service\n");
}

function onLoad() {

    try {
	// With Firefox 3.0 it will work
	// and with Fx3.5 it works only when 'Manage duplicates' window is opened just after startup ;-)
	Totalnum = BookmarksCount.getItemAtIndex(0).value;
    } catch (e) {
	// This part add support for Firefox 3.5
	//alert("BookmarkDD - internal error :\n" + "Totalnum = "+ Totalnum + " URLlist.itemCount = " + URLlist.itemCount + "\nError Name: " + e.name + "  Error Message: " + e.message + " file: " + e.fileName  + " line: " + e.lineNumber);
	try {
	    var mDBConn = Components.classes["@mozilla.org/browser/nav-history-service;1"]
				     .getService(Components.interfaces.nsINavHistoryService)
				     .QueryInterface(Components.interfaces.nsPIPlacesDatabase)
				     .DBConnection;

	    var statement = mDBConn.createStatement('SELECT COUNT(id) AS Number FROM moz_bookmarks WHERE type = 1 AND title NOT LIKE "" ');
	    while (statement.executeStep()) {
		Totalnum = statement.row.Number;
	    }
	    statement.finalize();

	    var statement2 = mDBConn.createStatement('SELECT url, fk AS "URL_id", COUNT(fk) AS Number FROM moz_bookmarks, moz_places WHERE moz_places.id=moz_bookmarks.fk AND moz_bookmarks.title NOT NULL GROUP BY fk HAVING COUNT (fk) > 1 ORDER BY Number DESC, url ASC');
	    var url_value = "";
	    var Number_value = "";
	    while (statement2.executeStep()) {
		url_value = statement2.row.url;
		Number_value = statement2.row.Number;
		addURL("URLlist",Number_value + "  -  " + url_value,url_value);
	    }
	    statement2.finalize();

	} catch(ex) {
	    alert("BookmarkDD - internal error :\n" + "Error Name: " + ex.name + "  Error Message: " + ex.message + " file: " + ex.fileName  + " line: " + ex.lineNumber);
	} finally {
	    statement.finalize();
	    statement2.finalize();
	}
    }

    DupNum = URLlist.itemCount;

    setMessage(DupNum, Totalnum);
    BookmarksCount.setAttribute('hidden','true');

    // if DupNum == 0 close window with congratulation
    if (DupNum == 0){
	prompts.alert(window, Bookmarkdd._stringLocalization.GetStringFromName("SearchDup-title"), Bookmarkdd._stringLocalization.GetStringFromName("SearchDup-none"));
	window.close();
	return true;
    }

    /*var messageAutoDelete = "";
    AutoDeleteAllDuplicates = WinArgs[3];

    if("arguments" in window && WinArgs.length > 0) {
	var listURL = WinArgs[0];
    }

    for(var i=0;i<listURL.length;i++){
	if(AutoDeleteSameFolder || AutoDeleteSelectedFolder){
	    if (! AutoDeleteDuplicatesBookmark(listURL[i])) addURL("Folderslist",listURL[i],i);
	} else addURL("Folderslist",listURL[i],i);
    }

    if (AutoDeletedBookmarkSameFolder>0 ){
	messageAutoDelete = Bookmarkdd._stringLocalization.formatStringFromName("DuplicatesAutoDelete-SameFolder", [AutoDeletedBookmarkSameFolder], 1);
	alert(messageAutoDelete);
    }
    if (AutoDeletedBookmarkSelectedFolder>0 ){
	messageAutoDelete = Bookmarkdd._stringLocalization.formatStringFromName("DuplicatesAutoDelete-SelectedFolder", [AutoDeletedBookmarkSelectedFolder], 1);
	alert(messageAutoDelete);
    }
*/
    if (URLlist.itemCount>15){URLlist.setAttribute('rows','15');}

    URLlist.setAttribute('onclick','ShowParentFolders(this.value);');
    URLlist.setAttribute('onkeypress','ShowParentFolders(this.value);');

    window.sizeToContent();

    //window.addEventListener("keypress", searchEscape, true);
    window.addEventListener("keyup", searchEscape, true);

}

// Event Listener to detect escape. Escape close window only if no item is selected.
// If a folder is selected it needs three escape key press to close window.
function searchEscape(aEvent){

    // if keyCode is not defined function is unuseful ;-)
    if (! aEvent.keyCode ) { return; } 

    if (Bookmarkdd.DEBUG) { Bookmarkdd.myDump("Key pressed is: "+aEvent.keyCode); }

    if (aEvent.keyCode == "27"){
	if (FolderslistID.selectedCount != 0) {
	    FolderslistID.clearSelection();
	    return;
	}

	if (URLlist.selectedCount != 0) {
	    document.getElementById("description-url").setAttribute('value',"");
	    removeAllItems("Folderslist");
	    URLlist.clearSelection();
	    return;
	}

	window.close();
    }

    //Detect delete key to delete URL in folderlist
    if (aEvent.keyCode == "46"){
	if (FolderslistID.selectedCount != 0 && FolderslistID.selectedCount < FolderslistID.itemCount) {
	    if (Bookmarkdd.DEBUG) { Bookmarkdd.myDump("Delete item : "+FolderslistID.selectedItem.value); }
	    deleteSelection();
	    return;
	}
    }

    //Synchronize selected url in URLlist with FolderslistID when keyboard arrow are pressed
    if (aEvent.keyCode == "37" ||
	    aEvent.keyCode == "38" ||
	    aEvent.keyCode == "39" ||
	    aEvent.keyCode == "40" ||
	    aEvent.keyCode == "33" ||
	    aEvent.keyCode == "34" ||
	    aEvent.keyCode == "35" ||
	    aEvent.keyCode == "36"
	    ){
	// if no element is already selected select first
	if (!URLlist.selectedItem) {
	    if (URLlist.getRowCount() > 0) {
		URLlist.selectedIndex = 0;
	    }
	}
	if (Bookmarkdd.DEBUG) { Bookmarkdd.myDump("URL selected is: "+URLlist.selectedItem.value); }
	ShowParentFolders(URLlist.selectedItem.value);
	return;
    }
}

function addURL(listID,label,value) {
    var FolderslistID = document.getElementById(listID);
    FolderslistID.appendItem(label,value);
}

function setMessage(Num, Total){
    var message ="";
    try {
	message = Bookmarkdd._stringLocalization.formatStringFromName("DuplicatesFound", [Num, Total], 2);
    }  catch(e){
    	message = "[translate me] Total URL Duplicated "+Num+" out of "+Total+" URLs in Bookmarks.";
    }

    var messageParent = document.getElementById("Find-message");
    messageParent.setAttribute('value',message);
}


// Function used to clear a listbox
function removeAllItems(myListBox) {

    var box = document.getElementById(myListBox);
    var rowCount = box.getRowCount();
    for( var i = rowCount; i > 0; i-- ) {
	box.removeItemAt(0);
    }

}


function deleteSelection() {
    //if (Bookmarkdd.DEBUG) { Bookmarkdd.myDump("deleteSelection function"); }
    var count = FolderslistID.selectedCount;
    // selectedItems array start from 0 so we decrease of 1 before to start loop
    count--;
    for(var i=count;i>=0;i--){
	if(!removeURL(FolderslistID.selectedItems[i])) continue;
	FolderslistID.removeItemAt(FolderslistID.getIndexOfItem(FolderslistID.selectedItems[i]));

	if(FolderslistID.getRowCount() < 3)  {
	    FolderslistID.setAttribute('seltype','single');
	} else FolderslistID.setAttribute('seltype','multiple');

	//If there is only one folder disable delete button to avoid remove of all URL references
	if (FolderslistID.getRowCount()<2) {
	    document.getElementById('b_delete').setAttribute('disabled','true');
	    document.getElementById('b_invertSelection').setAttribute('disabled','true');
	    var index=URLlist.getIndexOfItem(URLlist.selectedItem);

	    removeAllItems("Folderslist");
	    document.getElementById("description-url").setAttribute('value',"");

	    // Select the previous item in the list before delete current selected item
	    // So user can continuously delete item without navigate between both lists.
	    if (URLlist.getRowCount() > 1 && index >0) {
		URLlist.moveByOffset(-1,true,false);
		ShowParentFolders(URLlist.selectedItem.value);
	    }
	    // Delete selected item because there is no more duplicate of it
	    URLlist.removeItemAt(index);

	    // If previous selected item was the first in list (index=0)
	    // Select new first item in the list
	    if (URLlist.getRowCount() > 1 && index <1) {
		URLlist.selectedIndex = 0;
		ShowParentFolders(URLlist.selectedItem.value);
	    }

	    DupNum--;
	    setMessage(DupNum, Totalnum);
	    return true;
	}
    }
    return true;
}

function removeURL(aItem){

    var URLPath = aItem.label;
    var message ="";
    try {
	message = Bookmarkdd._stringLocalization.formatStringFromName("Remove-Confirmation", [document.getElementById("description-url").value, URLPath], 2);
    }  catch(e){
    	message = "[translate me] Are you sure to remove URL:\n"+document.getElementById("description-url").value+"\nin folder:\n"+URLPath;
    }

    //default result=true --> If confirmation is not asked delete URL
    var result = true;
    if(UserPrefs.getPref("bool","removeURL.Askconfirmation")) result = BddConfirm(message,true);
    if (result) { //Remove selected bookmark in Place
	if (Bookmarkdd.DEBUG) { Bookmarkdd.myDump("Bookmark deleted is: "+aItem.value); }
	//XXX Stiffux: Comment following line to DEBUG
	bmsvc.removeItem(aItem.value);
	
	Totalnum--;
	setMessage(DupNum, Totalnum);
	return true;
    }
    return false;
}


function openbmProperties(aItem,aEvent){

    //Show Properties if context Click button --> rigth mouse click
    if (aEvent.button != 2) return false;

    var appInfo = Components.classes["@mozilla.org/xre/app-info;1"]
			    .getService(Components.interfaces.nsIXULAppInfo);
    var versionChecker = Components.classes["@mozilla.org/xpcom/version-comparator;1"]
				   .getService(Components.interfaces.nsIVersionComparator);

    if(versionChecker.compare(appInfo.version, "4.0") >= 0) {
	// running under Firefox 4.0 or later
	PlacesUIUtils.showBookmarkDialog({ action: "edit"
					 , type: "bookmark"
					 , itemId: aItem.value
					 , readOnly: 0
					 }, window.top);
    } else {
	PlacesUIUtils.showItemProperties(FolderslistID.selectedItem.value,"bookmark");
	aParentWindow = window.top;

    // Preserve size attributes differently based on the fact the dialog has
    // a folder picker or not.
    //let minimalUI = "hiddenRows" in aInfo &&
     //               aInfo.hiddenRows.indexOf("folderPicker") != -1;
    //let dialogURL = aMinimalUI ?
     //               "chrome://browser/content/places/bookmarkProperties2.xul" :
      //              "chrome://browser/content/places/bookmarkProperties.xul";

	let dialogURL ="chrome://browser/content/places/bookmarkProperties.xul"; 
    let features =
      "centerscreen,chrome,modal,resizable=no";

    aParentWindow.openDialog(dialogURL, "",  features, { action: "edit"
					 , type: "bookmark"
					 , itemId: aItem.value
					 , readOnly: 0
					 });
    //return ("performed" in aInfo && aInfo.performed);
    }
    
    return;
}

// Function to delete all duplicates bookmarks
function RemoveAll(){
    for(var i = URLlist.itemCount; i > 0; i--){
	if (!URLlist.selectedItem) {
	    if (URLlist.getRowCount() > 0) {
		URLlist.selectedIndex = 0;
	    }
	}
	if (Bookmarkdd.DEBUG) { Bookmarkdd.myDump("URL selected is: "+URLlist.selectedItem.value); }
	var URL = URLlist.selectedItem.value;
	// Transform URL in URI ressource
	var uri = ios.newURI(URL, null, null);
	// Get all rows ID (from moz_bookmarks table) which have same URL
	// the result also include id of bookmark tag : one id for each tag attribute to a bookmark
	var ID_list_tags = bmsvc.getBookmarkIdsForURI(uri, {});
	// Filter to keep only bookmark : delete id corresponding to tags
	var bm_ID_list = ID_list_tags.filter(discardBookmark);
	// Find folder for each bookmark ID in list : result is ID of parent folder
	var bm_folder_id = bm_ID_list.map(bmsvc.getFolderIdForItem);
	// Find the path where it is each duplicate bookmark
	var bm_Folder_Path = bm_folder_id.map(Bookmarkdd.findPath);
	// In priority we will delete unclassified bookmarks : bookmarks which are in folder unclassified
	var unclassifiedDuplicate = new Array();
	for (var j = 0, length = bm_folder_id.length;j < length; j++) {
	    if (bm_folder_id[j] == bmsvc.unfiledBookmarksFolder) {
		//Bookmarkdd.myDump("Find unclassified bookmark for URL : "+URL);
		unclassifiedDuplicate[unclassifiedDuplicate.length]=j;
	    }
	}
	if (unclassifiedDuplicate.length >0 && unclassifiedDuplicate.length < bm_ID_list.length) {
	    for (var id in unclassifiedDuplicate) {
		//removeURL(unclassifiedDuplicate[id]);
		if (Bookmarkdd.DEBUG) { Bookmarkdd.myDump("Bookmark deleted is: "+bm_ID_list[unclassifiedDuplicate[id]]+ " URL = "+URL+" Folder = "+bm_Folder_Path[unclassifiedDuplicate[id]]); }
		//XXX Stiffux: Comment following line to DEBUG
		bmsvc.removeItem(bm_ID_list[unclassifiedDuplicate[id]]);
		bm_ID_list.splice(unclassifiedDuplicate[id],1); // delete element which it is at index specified
		bm_Folder_Path.splice(unclassifiedDuplicate[id],1); // delete element which it is at index specified
		Totalnum--;
		CountRemoveAllDuplicates++;
	    }
	}
	if ( bm_ID_list.length > 1 ) {
	    for (var id in bm_ID_list) {
		if (bm_ID_list.length == 1) { break; }
		if (Bookmarkdd.DEBUG) { Bookmarkdd.myDump("Bookmark deleted is (second pass): "+bm_ID_list[id]+ "-> URL = "+URL+" Folder = "+bm_Folder_Path[id]); }
		bm_ID_list.splice(id,1); // delete element which it is at index specified
		bm_Folder_Path.splice(id,1); // delete element which it is at index specified
		//XXX Stiffux: Comment following line to DEBUG
		bmsvc.removeItem(bm_ID_list[id]);
		Totalnum--;
		CountRemoveAllDuplicates++;
	    }
       	}
	// Remove URL from URL list
	URLlist.removeItemAt(0) ;
	// Decrease URL duplicate number
	DupNum--;
	// Update total number of bookmarks and total of duplicate URL after each URL processed
	// For big Place with lot duplicates, it could show the progression
	// It would be better to show a progress bar
	setMessage(DupNum, Totalnum);
    }
    removeAllItems("Folderslist");
    if (Bookmarkdd.DEBUG) { Bookmarkdd.myDump("Total of duplicates removed : "+CountRemoveAllDuplicates); }
    var messageAutoDelete = Bookmarkdd._stringLocalization.formatStringFromName("RemoveAllDuplicates", [CountRemoveAllDuplicates], 1);
    alert(messageAutoDelete);
}

/******************************************************************************************
// If two duplicates bookmarks are in same folder delete the second found.
// OR if a duplicate bookmark is in selected folder delete it.
function AutoDeleteDuplicatesBookmark(aURL){
    var URLPath = new Array();
    var selectedFolder = UserPrefs.getPref("string","AutoDelete.SelectedFolder");
    var searchSelectedFolder = new RegExp("^("+selectedFolder+")","i");

    /*  PROTECTION:
    *	There is always duplicate that user want to keep. So this is a protection to avoid to delete ALL.
    *   Selection of root Folder 'Bookmarks' will delete ONLY duplicates which aren't in subfolders.
    *
    if (!isNotRootFolder.exec(selectedFolder)) {
	searchSelectedFolder = new RegExp("^("+selectedFolder+")$","i");
    }

    var folders = null;
    var urlFeed = rssFeed.exec(aURL);
    if (!urlFeed) {
	folders = Bookmarkdd.isBookmarked(aURL);
    } else {
	folders = Bookmarkdd.isBookmarked(aURL,aURL);
    }

    var num = 0;
    if(folders.parents) {
	var URLParents = folders.parents;
	var URLrdfNodes = folders.RDFnodes;
	num = folders.parents.length;
    } else {
	//If there is no duplicate for this URL don't add it in URLlist --> return true
	//Exemple: http://bugzilla.mozdev.org/show_bug.cgi?id=14589#c6
	Bookmarkdd.myDump("AutoDeleteDuplicatesBookmark: impossible to find duplicate URLs for:"+ aURL);
	return true;
    }
    
    for (var i=0;i<folders.parents.length; i++){
	var alreadyIn = false;

	/*
	*   Delete ALL Duplicates URL if AutoDeleteAllDuplicates = true 
	*
	if(AutoDeleteAllDuplicates) {
	    if(num > 1) {
		//Remove bookmark in Bookmarks
		Bookmarkdd.myDump("(AutoDeleteAllDuplicates) Deleted URL: "+aURL+" duplicate in selected folder: "+URLParents[i]);
		var selection = Bookmarkdd.createSelection(URLrdfNodes[i]);
		BookmarksCommand.deleteBookmark(selection);
		AutoDeletedBookmarkSelectedFolder++;
		num--; Totalnum--;
	    }
	    // If Auto Delete ALL Duplicates don't test AutoDeleteSameFolder && AutoDeleteSelectedFolder
	    continue;
	}

    	if(AutoDeleteSameFolder) {
	    if(Bookmarkdd.version == "1.5"){
		    if(URLPath.indexOf(URLParents[i]) != -1) alreadyIn = true;
	    } else {
		    for (var count = 0; count < URLPath.length;count++){
			    if(!URLPath[count]) continue;
			    if(URLPath[count] == URLParents[i]) { alreadyIn = true; break; }
		    }
	    }

	    if(alreadyIn) {
		//Remove bookmark in Bookmarks
		Bookmarkdd.myDump("Deleted URL: "+aURL+" duplicate in same folder: "+URLParents[i]);
		var selection = Bookmarkdd.createSelection(URLrdfNodes[i]);
		BookmarksCommand.deleteBookmark(selection);
		AutoDeletedBookmarkSameFolder++;
		num--; Totalnum--;
		continue;
	    }
	}

	//if(filter(aURL,Folder)) continue;

	if(AutoDeleteSelectedFolder){
	    if(num > 1 && searchSelectedFolder.exec(URLParents[i])) {
		//Remove bookmark in Bookmarks
		Bookmarkdd.myDump("Deleted URL: "+aURL+" duplicate in selected folder: "+URLParents[i]);
		var selection = Bookmarkdd.createSelection(URLrdfNodes[i]);
		BookmarksCommand.deleteBookmark(selection);
		AutoDeletedBookmarkSelectedFolder++;
		num--; Totalnum--;
		continue;
	    }
	}

	if(!alreadyIn) {
	    if (Bookmarkdd.DEBUG) Bookmarkdd.myDump("Insert in URLPath array URL:\n"+aURL+"\nin folder tree:\n"+URLParents[i]);
	    URLPath.push(URLParents[i]);
	}
    }

    // If there is no more duplicate of this aURL, delete it in URLlist
    if( num == 1 ){
	DupNum--;
	setMessage(DupNum, Totalnum);
	return true;
    } else {
	if (Bookmarkdd.DEBUG) Bookmarkdd.myDump("Keep "+num+" copie(s) of URL: "+aURL);
    }

    return false;
}
******************************************************************************************/

// Function to discard unwanted bookmarks
// List of discarded bookmark : Tags, ...
function discardBookmark(element, index, array){
    if (Bookmarkdd.isItaTag(element)) { return false; }
    return true;
}

// Find parents from URL and add Folders name in List
function ShowParentFolders(URL) {
    // When escape is pressed or a click occurs on empty line URL is null
    if(!URL) return true;
 
    // Clear Parent Folder list before to show next list
    removeAllItems("Folderslist");

    // Transform URL in URI ressource
    var uri = ios.newURI(URL, null, null);

    // Get all rows ID (from moz_bookmarks table) which get this URL
    // and search the Chain of parents
    var result = bmsvc.getBookmarkIdsForURI(uri, {});
    var result_Filtered = result.filter(discardBookmark);
    var result_Folder = result_Filtered.map(bmsvc.getFolderIdForItem);
    var result_Folder_Path = result_Folder.map(Bookmarkdd.findPath);
    // Cannot sort due to impact on other array !!!
    //result_Folder_Path.sort();
    for (var i = 0;i < result_Folder_Path.length; i++) {
	addURL("Folderslist",result_Folder_Path[i],result_Filtered[i]);
	//Bookmarkdd.myDump("Investigation add :"+result_Folder_Path[i]+" "+result[i]);
	//Bookmarkdd.myDump("Must be add :"+result_Folder_Path[i]+" "+result_Filtered[i]);
    }
    if(result.length < 3)  {
	FolderslistID.setAttribute('seltype','single');
    } else FolderslistID.setAttribute('seltype','multiple');

    // The if condition is not useful if URL list is refresh correctly after deletion
    // when there is only one parent for URL the delete button MUST be disabled
    if(result.length > 1)  document.getElementById('b_delete').removeAttribute('disabled');
    if(result.length > 1)  document.getElementById('b_invertSelection').removeAttribute('disabled');

    // Do not modify number of rows in Folder list : sometimes the REMOVE button is not visible
    //FolderslistID.setAttribute('rows',eval(result.length+1));


    var TruncatedUrl = URL.substr(0,TRUNCATENUM);
    document.getElementById("description-url").setAttribute('value',TruncatedUrl);

    //XXX BUG Fx3 seems to not update sizemode to maximized every times
    // https://bugzilla.mozilla.org/show_bug.cgi?id=419292
    // So test sizemode and windowState : it seems that windowState=1 is sizemode=maximized
    //alert("Window Sizemode="+WindowSizeMode+"\nWindow State="+window.windowState);
    //It was stupid to resize windows following URL selection --> disable this behaviour
    //var WindowSizeMode = document.getElementById("bookmarkDD-ManageDuplicates").getAttribute('sizemode');
    //if(WindowSizeMode != "maximized" && window.windowState != "1" ){
	//window.sizeToContent();
    //}

    return true;
}


